public class Tester {

boolean[] G;

public void start() {
	generate(5);
 	System.out.println();
 	}

public void generate (int n){
	G = new boolean[n];
	// test counting up
	for (int i=0; i<n; i++) G[i]=false;
	for (int i=0; i<Math.pow(2,n); i++) {
		display(G);
		increment (G,false);
		}
	System.out.println();
	System.out.println();
	// test counting down
	for (int i=0; i<n; i++) G[i]=false;
	G[n-1]=true;
	for (int i=0; i<Math.pow(2,n); i++) {
		display(G);
		increment (G,true);
		}
	}

public void display(boolean[] G){
	for (int i=G.length-1; i>=0; i--)
		if (G[i]) System.out.print(1);
		else System.out.print(0);
	System.out.println();
	}

/* ALGORITHM A4: INCREMENT/DECREMENT A GRAY CODE WORD G OF WIDTH N */

public void increment (boolean [] G, boolean d){ // d 0 up, 1 down

	boolean p; // parity of word G
	int last1; // lowest i such that G[i] == 1
	// find parity and last1
		p = false;
		last1 = G.length;
		for (int i = G.length-1; i>=0; i--)
			if (G[i]) {
				p = ! p;
				last1 = i;
				}

	int switchPos; // index of bit to switch
	// find switchPos
		if (p ^ !d) 			 	switchPos = 0;
		else
		if (last1 < G.length-1) 	switchPos = last1+1;
		else 						switchPos = G.length-1;

	G[switchPos] = ! G[switchPos]; // switch the bit
	}
}











